package net.mcreator.bloonsballoons.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.4.1
// Exported for Minecraft version 1.17 - 1.18 with Mojang mappings
// Paste this class into your mod and generate all required imports
public class ModelBFB<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("bloons_balloons", "model_bfb"), "main");
	public final ModelPart bb_main;

	public ModelBFB(ModelPart root) {
		this.bb_main = root.getChild("bb_main");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition bb_main = partdefinition.addOrReplaceChild("bb_main",
				CubeListBuilder.create().texOffs(0, 0).addBox(-30.0F, -72.0F, -31.0F, 60.0F, 60.0F, 65.0F, new CubeDeformation(0.0F)).texOffs(185, 0)
						.addBox(-29.0F, -71.0F, 34.0F, 58.0F, 58.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 125)
						.addBox(-29.0F, -71.0F, -36.0F, 58.0F, 58.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(0, 188)
						.addBox(-27.0F, -69.0F, -43.0F, 54.0F, 54.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(248, 125)
						.addBox(-25.0F, -67.0F, -46.0F, 50.0F, 50.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(303, 0)
						.addBox(-22.0F, -64.0F, -48.0F, 44.0F, 44.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(350, 157)
						.addBox(-15.0F, -57.0F, -50.0F, 30.0F, 30.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(126, 125)
						.addBox(-28.0F, -70.0F, -41.0F, 56.0F, 56.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(238, 241)
						.addBox(-26.0F, -68.0F, -45.0F, 52.0F, 52.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(0, 295)
						.addBox(-24.0F, -66.0F, -47.0F, 48.0F, 48.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(98, 341)
						.addBox(-20.0F, -62.0F, -49.0F, 40.0F, 40.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 381)
						.addBox(-10.0F, -52.0F, -51.0F, 20.0F, 20.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(126, 186)
						.addBox(-28.0F, -70.0F, 35.0F, 56.0F, 56.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(240, 186)
						.addBox(-27.0F, -69.0F, 36.0F, 54.0F, 54.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(111, 243)
						.addBox(-26.0F, -68.0F, 37.0F, 52.0F, 52.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 244)
						.addBox(-25.0F, -67.0F, 38.0F, 50.0F, 50.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(250, 59)
						.addBox(-24.0F, -66.0F, 39.0F, 48.0F, 48.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(216, 295)
						.addBox(-23.0F, -65.0F, 40.0F, 46.0F, 46.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(98, 296)
						.addBox(-22.0F, -64.0F, 41.0F, 44.0F, 44.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(310, 295)
						.addBox(-21.0F, -63.0F, 42.0F, 42.0F, 42.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(310, 338)
						.addBox(-20.0F, -62.0F, 43.0F, 40.0F, 40.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(180, 342)
						.addBox(-19.0F, -61.0F, 44.0F, 38.0F, 38.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 344)
						.addBox(-18.0F, -60.0F, 45.0F, 36.0F, 36.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(346, 241)
						.addBox(-17.0F, -59.0F, 46.0F, 34.0F, 34.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(349, 93)
						.addBox(-16.0F, -58.0F, 47.0F, 32.0F, 32.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(350, 126)
						.addBox(-15.0F, -57.0F, 48.0F, 30.0F, 30.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(350, 188)
						.addBox(-14.0F, -56.0F, 49.0F, 28.0F, 28.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(310, 379)
						.addBox(-13.0F, -55.0F, 50.0F, 26.0F, 26.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(364, 379)
						.addBox(-12.0F, -54.0F, 51.0F, 24.0F, 24.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(350, 217)
						.addBox(-11.0F, -53.0F, 52.0F, 22.0F, 22.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(376, 45)
						.addBox(-10.0F, -52.0F, 53.0F, 20.0F, 20.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(346, 276)
						.addBox(-9.0F, -51.0F, 54.0F, 18.0F, 18.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(28, 0)
						.addBox(-8.0F, -50.0F, 55.0F, 16.0F, 16.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 48)
						.addBox(-7.0F, -49.0F, 56.0F, 14.0F, 14.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(30, 48)
						.addBox(-6.0F, -48.0F, 57.0F, 12.0F, 12.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(-5.0F, -47.0F, 58.0F, 10.0F, 10.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 11)
						.addBox(-4.0F, -46.0F, 59.0F, 8.0F, 8.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(112, 188)
						.addBox(-3.0F, -45.0F, 60.0F, 6.0F, 6.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(52, 20)
						.addBox(-2.0F, -44.0F, 61.0F, 4.0F, 4.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(18, 11)
						.addBox(-1.0F, -43.0F, 62.0F, 2.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(248, 176)
						.addBox(23.0F, -34.0F, 37.0F, 10.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(248, 176)
						.addBox(-33.0F, -34.0F, 37.0F, 10.0F, 4.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(58, 366)
						.addBox(-43.0F, -37.0F, 27.0F, 10.0F, 10.0F, 16.0F, new CubeDeformation(0.0F)).texOffs(58, 366)
						.addBox(33.0F, -37.0F, 27.0F, 10.0F, 10.0F, 16.0F, new CubeDeformation(0.0F)).texOffs(28, 17)
						.addBox(-46.0F, -33.0F, 26.0F, 16.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(28, 17)
						.addBox(-46.0F, -33.0F, 26.0F, 16.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(28, 17)
						.addBox(30.0F, -33.0F, 26.0F, 16.0F, 2.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition cube_r1 = bb_main.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(0, 0).addBox(20.0F, 1.0F, -4.0F, 2.0F, 24.0F, 24.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 51.0F, -0.6545F, 0.0F, -0.7854F));
		PartDefinition cube_r2 = bb_main.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(258, 342).addBox(19.0F, -31.0F, 0.0F, 2.0F, 24.0F, 24.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 51.0F, 0.7854F, 0.0F, -2.1817F));
		PartDefinition cube_r3 = bb_main.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(348, 45).addBox(-1.0F, -55.0F, 22.0F, 2.0F, 24.0F, 24.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -12.0F, 51.0F, 0.7854F, 0.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 512, 512);
	}

	@Override
	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green,
			float blue, float alpha) {
		bb_main.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}
}
